﻿@using Microsoft.AspNetCore.Components.Authorization
@using Microsoft.AspNetCore.Components.WebAssembly.Authentication
@using VacationSchedule.WebApp.Client.Services
@inherits LayoutComponentBase
@inject NavigationManager navigationManager
@inject CustomStateProvider authStateProvider

<div class="page">
    <div class="sidebar">
        <NavMenu />
    </div>

    <main>
        <div class="top-row px-4">
            <AuthorizeView>
                <Authorized>
                    <a href="profile">Hello, @context.User.Identity?.Name!</a>
                    <button class="nav-link btn btn-link" @onclick="@LogoutClick">Log out</button>
                </Authorized>
                <NotAuthorized>
                    <a href="/register">Register</a>
                    <a href="/login">Log in</a>
                </NotAuthorized>
            </AuthorizeView>
        </div>

        <article class="content px-4">
            @Body
        </article>
    </main>
</div>


@functions {
    [CascadingParameter]
    Task<AuthenticationState> AuthenticationState { get; set; }

    protected override async Task OnParametersSetAsync()
    {
        var userData = (await AuthenticationState).User;
        if (!userData.Identity.IsAuthenticated)
        {
            //TODO Отключение авторедиректа на авторизацию
            navigationManager.NavigateTo("/login");
        }

    }


    protected override async Task OnInitializedAsync()
    {
        navigationManager.NavigateTo("/profile");
    }
    async Task LogoutClick()
    {
        await authStateProvider.Logout();
        //TODO Отключение авторедиректа на авторизацию
        navigationManager.NavigateTo("/login");
    }
}